Package net.sf.saxon.expr.instruct

## Class ParentNodeConstructor

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.ParentNodeConstructor

- All Implemented Interfaces:
    `ExportAgent`, `InstructionWithComplexContent`, `TailCallReturner`, `ValidatingInstruction`, `Locatable`, `IdentityComparable`, `Traceable`
  Direct Known Subclasses:
    `DocumentInstr`, `ElementCreator`

      public abstract class ParentNodeConstructor
      extends Instruction
      implements ValidatingInstruction, InstructionWithComplexContent

  An abstract class to act as a common parent for instructions that create element nodes and document nodes.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Operand` | `contentOp` |
    `protected boolean` | `preservingTypes` | Flag set to true if validation=preserve and no schema type supplied for validation; also true when validation="strip" if there is no need to physically strip type annotations

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ParentNodeConstructor()` | Create a document or element node constructor instruction

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PathMap.PathMapNodeSet` | `addToPathMap​(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` | Add a representation of this expression to a PathMap.
    `boolean` | `allowExtractingCommonSubexpressions()` | Ask whether common subexpressions found in the operands of this expression can be extracted and evaluated outside the expression itself.
    `boolean` | `alwaysCreatesNewNodes()` | Ask whether it is guaranteed that every item in the result of this instruction is a newly created node
    `protected abstract void` | `checkContentSequence​(StaticContext env)` | Check that the child instructions don't violate any obvious constraints for this kind of node
    `int` | `computeCardinality()` | Get the cardinality of the sequence returned by evaluating this instruction
    `int` | `getCardinality()` | Determine the static cardinality of the expression.
    `Expression` | `getContentExpression()` | Get the expression that constructs the content of the element
    `Operand` | `getContentOperand()` |
    `SchemaType` | `getSchemaType()` | Get the schema type chosen for validation; null if not defined
    `int` | `getValidationAction()` | Get the validation mode for this instruction
    `ParseOptions` | `getValidationOptions()` | Get the validation options
    `boolean` | `isLocal()` |
    `boolean` | `isPreservingTypes()` | Determine whether this elementCreator performs validation or strips type annotations
    `boolean` | `mayCreateNewNodes()` | Determine whether this instruction creates new nodes.
    `Expression` | `optimize​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Perform optimisation of an expression and its subexpressions.
    `void` | `setContentExpression​(Expression content)` | Set the expression that constructs the content of the element
    `void` | `setNoNeedToStrip()` | Set that the newly constructed node and everything underneath it will automatically be untyped, without any need to physically remove type annotations, even though validation=STRIP is set.
    `void` | `setValidationAction​(int mode, SchemaType schemaType)` | Set the validation mode for the new document or element node
    `Expression` | `typeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextInfo)` | Perform type checking of an expression and its subexpressions.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, computeSpecialProperties, dynamicError, evaluateAsString, evaluateItem, getExpressionName, getImplementationMethod, getInstructionNameCode, getItemType, getNetCost, getSourceLocator, isInstruction, isXSLT, iterate, operands, process, processLeavingTail, someOperandCreatesNewNodes`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, checkedOperands, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeHashCode, computeStaticProperties, copy, dynamicError, effectiveBooleanValue, equals, evaluatePendingUpdates, explain, export, getConfiguration, getCost, getDependencies, getEvaluationMethod, getExtraProperty, getIntegerBounds, getInterpretedExpression, getIntrinsicDependencies, getLocalRetainedStaticContext, getLocation, getObjectName, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getStaticUType, getStreamerName, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, markTailFunctionCalls, operandList, operandSparseList, optimizeChildren, prepareForStreaming, resetLocalStaticProperties, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplify, simplifyChildren, staticTypeCheck, suppressValidation, toPattern, toShortString, toString, typeCheckChildren, typeError, unordered, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.trace.Traceable

      `gatherProperties`

- - ### Field Detail

    - #### contentOp

          protected Operand contentOp

    - #### preservingTypes

          protected boolean preservingTypes

      Flag set to true if validation=preserve and no schema type supplied for validation; also true when validation="strip" if there is no need to physically strip type annotations

  - ### Constructor Detail

    - #### ParentNodeConstructor

          public ParentNodeConstructor()

      Create a document or element node constructor instruction

  - ### Method Detail

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the schema type chosen for validation; null if not defined
      Specified by:
        `getSchemaType` in interface `ValidatingInstruction`
      Returns:
        the type to be used for validation. (For a document constructor, this is the required type of the document element)

    - #### getValidationOptions

          public ParseOptions getValidationOptions()

      Get the validation options
      Returns:
        the validation options for the content of the constructed node. May be null if no validation was requested.

    - #### setValidationAction

          public void setValidationAction​(int mode,
                                          SchemaType schemaType)

      Set the validation mode for the new document or element node
      Parameters:
        `mode` - the validation mode, for example `Validation.STRICT`
        `schemaType` - the required type (for validation by type). Null if not validating by type

    - #### getValidationAction

          public int getValidationAction()

      Get the validation mode for this instruction
      Specified by:
        `getValidationAction` in interface `ValidatingInstruction`
      Returns:
        the validation mode, for example `Validation.STRICT` or `Validation.PRESERVE`

    - #### setNoNeedToStrip

          public void setNoNeedToStrip()

      Set that the newly constructed node and everything underneath it will automatically be untyped, without any need to physically remove type annotations, even though validation=STRIP is set.

    - #### setContentExpression

          public void setContentExpression​(Expression content)

      Set the expression that constructs the content of the element
      Parameters:
        `content` - the content expression

    - #### getContentExpression

          public Expression getContentExpression()

      Get the expression that constructs the content of the element
      Specified by:
        `getContentExpression` in interface `InstructionWithComplexContent`
      Returns:
        the content expression

    - #### getContentOperand

          public Operand getContentOperand()

    - #### computeCardinality

          public int computeCardinality()

      Get the cardinality of the sequence returned by evaluating this instruction
      Overrides:
        `computeCardinality` in class `Instruction`
      Returns:
        the static cardinality

    - #### typeCheck

          public Expression typeCheck​(ExpressionVisitor visitor,
                                      ContextItemStaticInfo contextInfo)
                               throws XPathException

      Description copied from class: `Expression`
      Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

      This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextInfo` - Information available statically about the context item: whether it is (possibly) absent; its static type; its streaming posture.
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### allowExtractingCommonSubexpressions

          public boolean allowExtractingCommonSubexpressions()

      Ask whether common subexpressions found in the operands of this expression can be extracted and evaluated outside the expression itself. The result is irrelevant in the case of operands evaluated with a different focus, which will never be extracted in this way, even if they have no focus dependency.
      Overrides:
        `allowExtractingCommonSubexpressions` in class `Expression`
      Returns:
        false for this kind of expression

    - #### checkContentSequence

          protected abstract void checkContentSequence​(StaticContext env)
                                                throws XPathException

      Check that the child instructions don't violate any obvious constraints for this kind of node
      Parameters:
        `env` - the static context
      Throws:
        `XPathException` - if the check fails

    - #### optimize

          public Expression optimize​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextItemType)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### mayCreateNewNodes

          public final boolean mayCreateNewNodes()

      Determine whether this instruction creates new nodes. This implementation returns true.
      Overrides:
        `mayCreateNewNodes` in class `Instruction`
      Returns:
        true if the instruction creates new nodes under some input conditions (or if it can't be proved that it doesn't)

    - #### alwaysCreatesNewNodes

          public boolean alwaysCreatesNewNodes()

      Ask whether it is guaranteed that every item in the result of this instruction is a newly created node
      Overrides:
        `alwaysCreatesNewNodes` in class `Instruction`
      Returns:
        true if result of the instruction is always either an empty sequence or a sequence consisting entirely of newly created nodes

    - #### getCardinality

          public int getCardinality()

      Description copied from class: `Expression`
      Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.
      Overrides:
        `getCardinality` in class `Expression`
      Returns:
        one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

    - #### addToPathMap

          public PathMap.PathMapNodeSet addToPathMap​(PathMap pathMap,
                                                     PathMap.PathMapNodeSet pathMapNodeSet)

      Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

      The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

      Overrides:
        `addToPathMap` in class `Expression`
      Parameters:
        `pathMap` - the PathMap to which the expression should be added
        `pathMapNodeSet` - the PathMapNodeSet to which the paths embodied in this expression should be added
      Returns:
        the pathMapNodeSet representing the points in the source document that are both reachable by this expression, and that represent possible results of this expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

    - #### isPreservingTypes

          public boolean isPreservingTypes()

      Determine whether this elementCreator performs validation or strips type annotations
      Returns:
        false if the instruction performs validation of the constructed output or if it strips type annotations, otherwise true

    - #### isLocal

          public boolean isLocal()